SystemOrganization addCategory: #'Frank-Core'!

WARequestHandler subclass: #FSRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Frank-Core'!

!FSRequestHandler methodsFor: 'handling' stamp: 'pmm 7/9/2012 21:15'!
handleFiltered: aRequestContext
	aRequestContext consumer atEnd
		ifTrue: [ self listing: aRequestContext ]
		ifFalse: [ self receive: aRequestContext ]! !

!FSRequestHandler methodsFor: 'private' stamp: 'pmm 7/9/2012 21:25'!
handleSelector: aSymbol context: aRequestContext
	| content |
	content := [ self perform: aSymbol ]
		on: Error
		do: [ :error | 
			^ aRequestContext responseGenerator
				internalError: error;
				respond ].
			
	aRequestContext respond: [ :response | 
			response
				contentType: WAMimeType textHtml;
				nextPutAll: content ]! !

!FSRequestHandler methodsFor: 'routes' stamp: 'pmm 7/9/2012 21:26'!
index
	^ ''! !

!FSRequestHandler methodsFor: 'private' stamp: 'pmm 7/9/2012 21:26'!
listing: aRequestContext
	self handleSelector: #index context: aRequestContext! !

!FSRequestHandler methodsFor: 'private' stamp: 'pmm 7/9/2012 21:25'!
receive: aRequestContext
	| selector |
	selector := aRequestContext consumer next asSymbol.
	selector isUnary
		ifTrue: [
			self handleSelector: selector context: aRequestContext ]
		ifFalse: [
			aRequestContext responseGenerator
				notFound;
				respond ] ! !
